;------------------------------------------------
;
;                  TUTO  -  ASM
;
;------------------------------------------------
;    Essai de programmation d'un jeu en ASM
;------------------------------------------------
;				  MSXosaure 2014...
;------------------------------------------------
;
;------------------------------------------------
;                 Initialisation
;------------------------------------------------
       .bios
       .page   2
       .rom
       .start  DEBUT
;
;------------------------------------------------
; 			Constantes VRAM
;------------------------------------------------
       CHRTBL  equ     0000h
       NAMTBL  equ     1800h
       CLRTBL  equ     2000h
       SPRTBL  equ     3800h
       SPRATR  equ     1b00h
;------------------------------------------------
DEBUT:
; slection screen
       call    DISSCR
; rglage COLOR 11,1,1
        ld      hl,0f3e9h
        ld      [hl],15
        inc     hl
        ld      [hl],12
        inc     hl
        ld      [hl],1
; SCREEN 2
        call    INIGRP
; SCREEN ,2
        ld      bc,06201h
        call    WRTVDP
; Mise  zro de la VRAM
	ld hl,0000h
	ld bc,4000h
	xor a
	call FILVRM		
; Definition des formes patterns
  ld	de,0
  call	GST_BANK
  ld	de,256*8
  call	GST_BANK  
  ld	de,512*8
  call	GST_BANK 
; Definition des formes sprites
        ld      hl,SPR_PATRON
        ld      de,SPRTBL; + 32
        ld      bc,20*32
        call    LDIRVM	
; initialisation des attributs sprites
        ld      hl,ATT_SPRITES	; on prend les paramtres initiaux
        ld      de,VAR_SPRITES	;  envoyer vers les variables des sprites
        ld      bc,2*4			; nombre de sprites * nb d'attributs (a va voluer)
       ldir						; on lance la "copie"

; Sauvegarde du hook original H.TIMI 
        ld    hl,$fd9f			; ou HTIMI pour les intimes 
        ld    de,REFRESH_OLD 
        ld    bc,5 
        ldir 
; Mise en place de la drivation de l'interruption REFRESH 
        di 
        ld    hl,REFRESH
        ld    [$fd9f+1],hl	; ou HTIMI+1 pour les intimes on y dpose l'adresse du saut
        ld    a,0C3h        ; opcode "JP" 
        ld    [$fd9f],a		; ou HTIMI pour les intimes on y dpose le "jump"
        ei 
;
xor a
	ld	[VAR_ANI_H],a
	call	GST_CARTE
;-----------------------------------------------!
;												!
;												!
;												!
;			   BOUCLE PRINCIPALE				!
;												!
;												!
;												!
LOOP:
    call    WAIT_REFRESH 
	call 	GST_DEP_Heros	
	call 	GST_SPRITES	
	call	GST_DEFILE_1	; Scrolling premier plan plus rapide
    ld    	a,[VAR_TIMER] 	; Chargement du timer
    and    	1 				; toutes les 8 frames
	call	z,GST_DEFILE_2  ; Scrolling second plan	
	ld    	a,[VAR_TIMER] 	; Chargement du timer
    and    	3 				; toutes les 8 frames
	call	z,GST_DEFILE_3  ; scrolling troisime plan 	
jp		LOOP
;-----------------------------------------------!
;
;
;
;- - - SOUS PROGRAMME BOUCLE	- - -
;
;----------------------------------------------------------
GST_DEFILE_1:	;---- 	Gestion Scrolling premier plan 	-----
;----------------------------------------------------------
ld		hl,CHRTBL+(512*8)+8+16	;chargement caractres eau et quai
ld 		b,16					; longueur de ces caractres
call	SCROLL					; Vers la mise en place du scrolling
ld		a,-1					; consquence = recul...
jp		X_MOVE					; du hros!
;
;----------------------------------------------------------
GST_DEFILE_2:	;---- 	Gestion Scrolling second plan 	-----
;----------------------------------------------------------
ld	hl,CHRTBL+(512*8)+8	;chargement caractres mur
ld 	b,16				; longueur de ces caractres
jp	SCROLL				; Vers la mise en place du scrolling
;
;----------------------------------------------------------
GST_DEFILE_3:	;---- 	Gestion Scrolling troisime plan 	-----
;----------------------------------------------------------
ld	hl,CHRTBL+(512*8)+8+32	;chargement caractres verdure
ld 	b,24					; longueur de ces caractres
JP	SCROLL					; Vers la mise en place du scrolling
;
;----------------------------------------------------------
SCROLL:
;----------------------------------------------------------
call	RDVRM				; ligne de caractre dans a
rlca						; rotation vers la gauche
call	WRTVRM				; remise de la ligne dans la VRAM
inc 	hl					; au suivant!
DJNZ	SCROLL				; on boucle "b" fois 
ret
;
;----------------------------------------------------------
GST_DEP_Heros:	;---- 	Gestion mouvement 	-----
;----------------------------------------------------------
;
    xor     a			; A=0 (test clavier) 
    call    GTSTCK		; A= direction flches clavier 
    cp      0			; Si A=0
    jr     	nz,@@GST_MOVE	; si non (a<>0) saut  la boucle  
    inc     a			; si oui A=A+1 (A=1)
    call    GTSTCK		; A= direction manette 1 
    cp      0			; Si A=0	
	jr     	nz,@@GST_MOVE	; si non (a<>0) saut  la boucle
ret
;  
;	Gestion mouvement
@@GST_MOVE:
    push  	af			; sauve a (valeur joystick)
; Orientation sprite
	dec a				; on dcale de -1 pour partir de 0
	ld	hl,VAL_ORI_H	; HL = adr. orientation heros
	ld	b,0				; mise dans BC de a
	ld	c,a				; 	"
	add	hl,bc			; HL = On met HL  l'adresse correspondant  adresse d'orientation voulue.
	ld	a,[hl]			; on met la valeur dans a
; Animation sprite 
    ld    b,a            ; plus rapide que push af et permet de prparer l'addition 
    ld    a,[VAR_TIMER] ; Chargement du timer
    and    7 				; toutes les 8 frames
    ld    a,[VAR_ANI_H]    ; charger a ne modifie pas les flags (pour le 'jp nz') et permet d'anticiper l'opration 
    jp    nz,@@suite 	; saut  "pas de modif" si NON
	xor 8				; inversion (0 ou 8)
	ld	[VAR_ANI_H],a	; sauvegarde de la variable
@@suite:
    add    a,b 			;l'ajouter ...l'orientation du hros sauvegarde
    ld     [VAR_SPRITES+(0*4)+2],a ; N 1er sprite heros (plan0)
    add    4            ; plus rapide que 4x 'inc a' 
    ld     [VAR_SPRITES+(1*4)+2],a ; N 2nd sprite heros(plan1)

; Dplacement horizontaux
 	pop af
;    push  	af			; sauve A (valeur joystick)

	ld	hl,VAL_DEP_X	; HL = adr. dplacement X
	ld	b,0				; mise dans BC de A
	ld	c,a				; 	"
	add	hl,bc			; HL = On met HL  l'adresse correspondant  adresse de dplacement en X + position manette.
	ld	a,[hl]			; a = val. dplacement X
X_MOVE:
	ld	b,a				; B = val. dplacement X
	ld	a,[VAR_SPRITES+1] 	; a=X avant dplacement
	add	b				; a=a+val. dplacement X
	cp 	6				; si X=X mini -2 (<  X mini)
	jr 	nz,@@X_MAX		; si non saut  X_MAX
	ld	a,8			; si oui X=X mini
	jp	@@X_MAJ			; et saut  MAJ de X
@@X_MAX:
	cp 	234				; si X=X maxi +2 (>  X maxi)
	jr 	nz,@@X_MAJ		; si non saut  MAJ de X
	ld	a,232			; si oui X=X maxi
@@X_MAJ:
	ld 	[VAR_SPRITES+(0*4)+1],a	; X 1er sprite heros (plan0)
	ld 	[VAR_SPRITES+(1*4)+1],a  	; X 2nd sprite heros(plan1)
ret	; Retour  la boucle principale
;
;----------------------------------------------------------- 
; Attente REFRESH 
;----------------------------------------------------------- 
WAIT_REFRESH: 
        ld      hl,VAR_TIMER 
        ld      a,[VAR_TIMER] 
@@loop: cp      [hl] 
        jr      z,@@loop 
        ret 
;
;------------------------------------------------------
;
;- - - 		SOUS PROGRAMME		- - -
;
;------------------------------------------------------
;
;------------------------------------------------------
GST_BANK:	; Definition des positions des patterns
;------------------------------------------------------
;
; Definition des formes patterns
        push	de
		ld      hl,CHRTBL+8
		add		hl,de
        ld      de,TIL_PATRON
		ex		de,hl
        ld      bc,22*8
        call    LDIRVM	
		
; Definition des couleurs patterns
        pop		de
		ld      hl,CLRTBL+8
		add		hl,de
        ld      de,TIL_COULEUR
		ex		de,hl
        ld      bc,22*8
        call    LDIRVM	
ret

;------------------------------------------------------
GST_CARTE:	; Definition des positions des patterns
;------------------------------------------------------
;
        ld      hl,TIL_CARTE
        ld      de,NAMTBL
        ld      bc,32*24
        call    LDIRVM	
ret
;
;------------------------------------------------------
GST_SPRITES:	;- envoi variables vers sprites 
;------------------------------------------------------
;
        ld      hl,VAR_SPRITES	; on prend les variables des sprites
        ld      de,SPRATR		;  envoyer vers les attributs de sprites en VRAM
        ld      bc,2*4			; nombre de sprites * nb d'attributs (a va voluer)
        call    LDIRVM			; c'est parti!
ret	
;----------------------------------------------------------- 
; Interruption sur REFRESH 
;----------------------------------------------------------- 
REFRESH: 
; Incrmentation du compteur REFRESH 
        ld       a,[VAR_TIMER] 
        inc      a 
        cp       128
        jr       nz,CYCLE 
        xor      a 
CYCLE:  ld       [VAR_TIMER],a 
; Excution du hook original HTIMI et fin de gestion des interruptions 
        jp       REFRESH_OLD
;
;----------------------------------------------------------
; 						Donnes
;----------------------------------------------------------
;		
; Patron des sprites
SPR_PATRON:
.INCLUDE"data_sprites.asm"	
;
; Attribut sprites 
;
; X, Y, N, Couleur
ATT_SPRITES:
	db	152,152,16,1	
	db	152,152,20,11	
; Test dplacement
VAL_DEP_X:
;------ 0,1,2,3,4,5,6, 7,8
	db  0,0,2,2,2,0,-2,-2,-2
VAL_DEP_Y:
;------ 0, 1,2,3,4,5,6,7,8
	db  0,-2,0,0,0,2,0,0,0
; orientation du heros
VAL_ORI_H:	
;------ 1, 2, 3, 4, 5, 6, 7, 8
	db  0,16,16,16,32,48,48,48
; Patrons des patterns	
TIL_PATRON:
db 0FFh,00Fh,0C3h,0F0h,0FFh,010h,010h,010h
db 0FFh,001h,001h,001h,0FFh,010h,010h,010h
db 0FFh,080h,080h,07Fh,000h,044h,0EDh,0FFh
db 0FFh,0F7h,0FFh,0FFh,074h,024h,0DBh,07Fh
db 0FFh,0FFh,0FFh,0FFh,0FFh,010h,0B8h,080h
db 0FFh,0FFh,001h,000h,000h,010h,0B8h,080h
db 000h,000h,08Ch,0C0h,000h,006h,00Ch,0C0h
db 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
db 080h,0C0h,0E0h,0F0h,0F8h,0FCh,0FEh,0FFh
db 001h,003h,007h,00Fh,01Fh,03Fh,07Fh,0FFh
db 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
db 000h,000h,000h,001h,007h,01Fh,0C0h,000h
db 0FFh,0FFh,078h,003h,000h,000h,000h,000h
db 0FFh,0FFh,0FFh,0FFh,00Fh,003h,000h,000h
db 000h,000h,000h,000h,000h,0F0h,007h,001h
db 000h,000h,000h,0B0h,0FFh,0FFh,0FFh,0FFh
db 000h,000h,000h,000h,083h,0FFh,0FFh,0FFh
db 000h,000h,000h,000h,00Fh,07Fh,0FFh,0FFh
db 000h,000h,001h,00Fh,0FFh,0FFh,0FFh,0FFh
db 080h,0C0h,0C0h,0E0h,0F0h,0F8h,0FCh,0FFh
db 001h,003h,007h,00Fh,01Fh,03Fh,07Fh,0FFh
db 000h,000h,000h,000h,000h,000h,000h,000h
db 0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
; color data
TIL_COULEUR:
db 0E1h,096h,096h,096h,0EAh,0E6h,0E6h,0E6h
db 0E6h,0E6h,0E6h,0E6h,0E6h,0E6h,0E6h,0E6h
db 0E6h,0EFh,0EFh,0E1h,0E1h,0E1h,0E1h,0E1h
db 0E1h,0E1h,0E1h,0E1h,0FEh,05Fh,05Fh,05Fh
db 0E1h,0E1h,0E1h,0E1h,0E1h,03Eh,03Eh,023h
db 071h,071h,037h,037h,037h,027h,027h,02Ch
db 023h,023h,023h,023h,023h,023h,023h,023h
db 051h,051h,051h,051h,051h,051h,051h,051h
db 0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h
db 0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h
db 0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h
db 0E7h,0E7h,0E7h,0E7h,0F7h,0F7h,0EFh,0EFh
db 071h,071h,0F7h,0EFh,0EFh,0EFh,0EFh,0EFh
db 071h,071h,071h,071h,07Fh,0EFh,0EFh,0EFh
db 0E7h,0E7h,0E7h,0E7h,0F7h,0F7h,07Fh,0EFh
db 0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh
db 0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh
db 0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh
db 0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh,0EFh
db 0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h
db 0E7h,0F7h,0E7h,0E7h,0E7h,0E7h,0E7h,0E7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h,0F7h
db 077h,077h,077h,077h,077h,077h,077h,077h
db 0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h


	;	
TIL_CARTE:
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 12, 13, 14, 15
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 21, 16, 17, 18, 19
    db  20, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11
    db  11,  9, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11
    db  11, 11,  9, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11,  9, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11,  9, 22, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11,  9, 22, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11,  9, 22, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11, 11,  9, 22, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11, 11, 11,  9, 22, 22, 22, 22, 22
    db  22, 22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11, 11, 11, 11,  9, 22, 22, 22, 22
    db  22, 22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11, 11, 11, 11, 11,  9, 22, 22, 22
    db  22, 22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,  9, 22, 22
    db  22, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,  9, 22
    db  10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
    db  11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,  9
    db   5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5
    db   5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5
    db   7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7
    db   7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7
    db   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
    db   1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
    db   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
    db   2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2
    db   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3
    db   3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3
    db   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4
    db   4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4
    db   8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8
    db   8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8 
;
;----------------------------------------------------------
; VARIABLES
;----------------------------------------------------------
        .page   3
;
; variables sprites
VAR_SPRITES:
    ds  2*4
; variable pour la tempo
VAR_TIMER:	
	ds	1
;hook original H.TIMI
REFRESH_OLD:
	ds	5	
; variable animation heros
VAR_ANI_H:
	ds	1